image: gradle:8-jdk21

include:
  - project: rug-digitallab/resources/gitlab-ci-templates
    ref: develop
    file:
      - gradle/static-analysis/static-analysis.yml
      - gradle/coverage/coverage.yml
      - gradle/test/unit-tests-with-docker.yml
      - gradle/release/release.yml
      - gradle/release/publish.yml
      - gradle/build/compile-kotlin.yml

stages:
  - build
  - test
  - coverage
  - pre-release
  - release
  - post-release
  - publish
  - static-analysis

variables:
  # Set the gradle user home to a subdirectory of the build directory,
  # enable the build cache, and print verbose output.
  GRADLE_CLI: "./gradlew --gradle-user-home gradle-home/ --build-cache -i"
  JAVA_OPTS: "-Xmx4G" # Fixes spotbugs OOM error

cache:
  key:
    files:
      # When the gradle wrapper changes, invalidate cache
      - gradle/wrapper/gradle-wrapper.properties
  paths:
    - gradle-home/wrapper/
    - gradle-home/caches/
    - gradle-home/notifications/
